Subject: bug#46469: 27.1; `isearch-del-char' should move point further back

From: Augusto Stoffel <[email-masked]>
Date: Wed, 28 Apr 2021 23:16:11 +0200

> But this change will cause a problem to me.  Usually, I type 'C-s'
> several times with a non-empty search string to arrive to Nth occurrence.
> Then to be able to continue the search with a shorter string, I remove
> some characters from the search string with 'C-M-d' (isearch-del-char).
> Then continue searching with 'C-s' from the same place.  But with the patch,
> 'C-M-d' unexpectedly jumps to a previous match, and every next 'C-M-d'
> jumps back it its previous match that makes no sense.

I can verify this.  But I think you just found a related but independent
issue.  Consider this example:

(progn
  (save-excursion (insert "a1 b2 a3"))
  (isearch-mode t t)
  (isearch-printing-char ?a)
  (isearch-repeat-forward)
  (isearch-printing-char ?\\)
  (isearch-printing-char ?|)
  (isearch-printing-char ?b))

When "\\|b" is added to search string, the point is at "3".  So it
shouldn't move, right?  But instead it goes back to "2".

Do you get the same behavior?